Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/ImageService.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/ImageService.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/ImageService.java	(revision 9919)
@@ -1,66 +1,14 @@
 package fr.mael.jiwigo.service;
 
-import java.io.File;
 import java.io.IOException;
 import java.security.NoSuchAlgorithmException;
 import java.util.List;
 
-import fr.mael.jiwigo.dao.ImageDao;
 import fr.mael.jiwigo.om.Image;
 import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
 import fr.mael.jiwigo.transverse.exception.WrongChunkSizeException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
-import fr.mael.jiwigo.transverse.util.ImagesUtil;
-import fr.mael.jiwigo.transverse.util.Tools;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
- *
-
- * @author mael
- *
- */
-public class ImageService {
-
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(ImageService.class);
-
-    /**
-     * Singleton
-     */
-    private static ImageService instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * @return the singleton
-     */
-    public static ImageService getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new ImageService(sessionManager);
-	}
-	return instance;
-    }
-
-    /**
-     * private constructor to use a singleton
-     */
-    private ImageService(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
+public interface ImageService {
 
     /**
@@ -72,7 +20,5 @@
      */
     public List<Image> listByCategory(Integer categoryId, boolean rafraichir) throws IOException,
-	    ProxyAuthenticationException {
-	return ImageDao.getInstance(sessionManager).listByCategory(categoryId, rafraichir);
-    }
+	    ProxyAuthenticationException;
 
     /**
@@ -92,41 +38,5 @@
     public boolean create(String filePath, Integer idCategory, Integer originalWidth, Integer originalHeight,
 	    Double chunckSize, Integer privacyLevel) throws IOException, NoSuchAlgorithmException,
-	    FileAlreadyExistsException, ProxyAuthenticationException, WrongChunkSizeException {
-	File originalFile = new File(filePath);
-	//get the byte array of the original file, to keep metadata
-	byte[] bytesFichierOriginal = Tools.getBytesFromFile(originalFile);
-
-	//resize the picture (or not)
-	boolean originaleRedimensionnee = ImagesUtil.scale(filePath, "originale.jpg", originalWidth, originalHeight);
-	//create the thumbnail
-	ImagesUtil.scale(filePath, "thumb.jpg", 120, 90);
-	//get the thumbnail
-	File thumbnail = new File(System.getProperty("java.io.tmpdir") + "/thumb.jpg");
-	File originale = null;
-	if (originaleRedimensionnee) {
-	    originale = new File(System.getProperty("java.io.tmpdir") + "/originale.jpg");
-	    //if the original file has been resized, we put the metadata in the resized file
-	    //I use here a try catch because if the original file isn't a jpeg
-	    //the methode Outil.enrich will fail, but the procedure has to continue
-	    try {
-		byte[] fichierEnrichi = Tools.enrich(bytesFichierOriginal, Tools.getBytesFromFile(new File(System
-			.getProperty("java.io.tmpdir")
-			+ "/originale.jpg")));
-		Tools.byteToFile(System.getProperty("java.io.tmpdir") + "/originale.jpg", fichierEnrichi);
-	    } catch (Exception e) {
-	    }
-	} else {
-	    originale = originalFile;
-
-	}
-	Image image = new Image();
-	image.setName(getImageName(filePath));
-	image.setThumbnail(thumbnail);
-	image.setOriginale(originale);
-	image.setIdCategory(idCategory);
-	image.setPrivacyLevel(String.valueOf(privacyLevel));
-	//now we call the dao to send the image to the webservice
-	return ImageDao.getInstance(sessionManager).create(image, chunckSize * 1000000);
-    }
+	    FileAlreadyExistsException, ProxyAuthenticationException, WrongChunkSizeException;
 
     /**
@@ -138,7 +48,5 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean addTags(Image image, String tagId) throws IOException, ProxyAuthenticationException {
-	return ImageDao.getInstance(sessionManager).addTags(image.getIdentifier(), tagId);
-    }
+    public boolean addTags(Image image, String tagId) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -149,19 +57,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Image> search(String queryString) throws IOException, ProxyAuthenticationException {
-	return ImageDao.getInstance(sessionManager).search(queryString);
-    }
-
-    /**
-     * Deletes the file extension
-     * @param path
-     * @return
-     */
-    private String getImageName(String path) {
-	File fichier = new File(path);
-	StringBuffer name = new StringBuffer(fichier.getName());
-	return (name.delete(name.lastIndexOf("."), name.length())).toString();
-
-    }
+    public List<Image> search(String queryString) throws IOException, ProxyAuthenticationException;
 
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/TagService.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/TagService.java	(revision 9902)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/TagService.java	(revision 9919)
@@ -4,57 +4,9 @@
 import java.util.List;
 
-import fr.mael.jiwigo.dao.TagDao;
 import fr.mael.jiwigo.om.Image;
 import fr.mael.jiwigo.om.Tag;
 import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
-import fr.mael.jiwigo.transverse.session.SessionManager;
 
-/*
- *  jiwigo-ws-api Piwigo webservice access Api
- *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
- *                All Rights Reserved
- *
- *  This library is free software. It comes without any warranty, to
- *  the extent permitted by applicable law. You can redistribute it
- *  and/or modify it under the terms of the Do What The Fuck You Want
- *  To Public License, Version 2, as published by Sam Hocevar. See
- *  http://sam.zoy.org/wtfpl/COPYING for more details.
- */
-/**
- *
-
- * @author mael
- *
- */
-public class TagService {
-    /**
-     * Logger
-     */
-    public static final org.apache.commons.logging.Log LOG = org.apache.commons.logging.LogFactory
-	    .getLog(TagService.class);
-
-    /**
-     * The instance, to use a singleton
-     */
-    private static TagService instance;
-
-    private SessionManager sessionManager;
-
-    /**
-     * @return the singleton
-     */
-    public static TagService getInstance(SessionManager sessionManager) {
-	if (instance == null) {
-	    instance = new TagService(sessionManager);
-	}
-	return instance;
-    }
-
-    /**
-     * private constructor
-     */
-    private TagService(SessionManager sessionManager) {
-	this.sessionManager = sessionManager;
-    }
+public interface TagService {
 
     /**
@@ -64,7 +16,5 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Tag> list() throws IOException, ProxyAuthenticationException {
-	return TagDao.getInstance(sessionManager).list();
-    }
+    public List<Tag> list() throws IOException, ProxyAuthenticationException;
 
     /**
@@ -75,9 +25,5 @@
      * @throws ProxyAuthenticationException
      */
-    public boolean create(String nom) throws IOException, ProxyAuthenticationException {
-	Tag tag = new Tag();
-	tag.setName(nom);
-	return TagDao.getInstance(sessionManager).create(tag);
-    }
+    public boolean create(String nom) throws IOException, ProxyAuthenticationException;
 
     /**
@@ -88,7 +34,4 @@
      * @throws ProxyAuthenticationException
      */
-    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException {
-	return TagDao.getInstance(sessionManager).tagsForImage(image);
-    }
-
+    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException;
 }
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CategoryServiceImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CategoryServiceImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CategoryServiceImpl.java	(revision 9919)
@@ -0,0 +1,107 @@
+package fr.mael.jiwigo.service.impl;
+
+import java.io.IOException;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import fr.mael.jiwigo.dao.CategoryDao;
+import fr.mael.jiwigo.om.Category;
+import fr.mael.jiwigo.service.CategoryService;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+
+ * @author mael
+ *
+ */
+public class CategoryServiceImpl implements CategoryService {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(CategoryServiceImpl.class);
+
+    private CategoryDao dao;
+
+    /**
+     * Lists all categories
+     * @param recursive true : recursive listing
+     * @return the list of categories
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Category> list(boolean recursive) throws IOException, ProxyAuthenticationException {
+	return dao.list(recursive);
+    }
+
+    /**
+     * Allows to create the categories tree
+     * @return list of categories
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Category> makeTree() throws IOException, ProxyAuthenticationException {
+	List<Category> list = dao.list(true);
+	for (Category category : list) {
+	    for (Category category2 : list) {
+		if (category2.getIdParentCategories().size() != 1
+			&& category.getIdentifier().equals(
+				category2.getIdParentCategories().get(category2.getIdParentCategories().size() - 2))) {
+		    category.getChildCategories().add(category2);
+		    category2.getParentCategories().add(category);
+		}
+
+	    }
+	}
+
+	return list;
+
+    }
+
+    /**
+     * creation of a category
+     * @param nom name of the category
+     * @param parent parent category
+     * @return true if successful
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(String nom, Integer parent) throws ProxyAuthenticationException {
+	Category category = new Category();
+	category.setDirectParent(parent);
+	category.setName(nom);
+	return dao.create(category);
+    }
+
+    /**
+     * creation of a category without parent
+     * @param nom name of the category
+     * @return true if successful
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(String nom) throws ProxyAuthenticationException {
+	Category category = new Category();
+	category.setName(nom);
+	return dao.create(category);
+    }
+
+    public CategoryDao getDao() {
+	return dao;
+    }
+
+    public void setDao(CategoryDao dao) {
+	this.dao = dao;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CommentServiceImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CommentServiceImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/CommentServiceImpl.java	(revision 9919)
@@ -0,0 +1,75 @@
+package fr.mael.jiwigo.service.impl;
+
+import java.io.IOException;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import fr.mael.jiwigo.dao.CommentDao;
+import fr.mael.jiwigo.om.Comment;
+import fr.mael.jiwigo.service.CommentService;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+
+ * @author mael
+ *
+ */
+public class CommentServiceImpl implements CommentService {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(CommentServiceImpl.class);
+
+    private CommentDao dao;
+
+    /**
+     * Lists all comments for an image
+     * @param imageId the id of the image
+     * @return the list of comments
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Comment> list(Integer imageId) throws IOException, ProxyAuthenticationException {
+	return dao.list(imageId);
+    }
+
+    /**
+     * Creates a comment for an image
+     * @param content the comment
+     * @param imageId the id of the image
+     * @param auteur the author of the comment
+     * @return true if successful
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(String content, Integer imageId, String auteur) throws IOException,
+	    ProxyAuthenticationException {
+	Comment comment = new Comment();
+	comment.setContent(content);
+	comment.setImageId(imageId);
+	comment.setAuthor(auteur);
+	return dao.create(comment);
+    }
+
+    public CommentDao getDao() {
+	return dao;
+    }
+
+    public void setDao(CommentDao dao) {
+	this.dao = dao;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/ImageServiceImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/ImageServiceImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/ImageServiceImpl.java	(revision 9919)
@@ -0,0 +1,155 @@
+package fr.mael.jiwigo.service.impl;
+
+import java.io.File;
+import java.io.IOException;
+import java.security.NoSuchAlgorithmException;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import fr.mael.jiwigo.dao.ImageDao;
+import fr.mael.jiwigo.om.Image;
+import fr.mael.jiwigo.service.ImageService;
+import fr.mael.jiwigo.transverse.exception.FileAlreadyExistsException;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+import fr.mael.jiwigo.transverse.exception.WrongChunkSizeException;
+import fr.mael.jiwigo.transverse.util.ImagesUtil;
+import fr.mael.jiwigo.transverse.util.Tools;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+ *
+
+ * @author mael
+ *
+ */
+public class ImageServiceImpl implements ImageService {
+
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(ImageServiceImpl.class);
+
+    private ImageDao dao;
+
+    /**
+     * Lists all images for a category
+     * @param categoryId the id of the category
+     * @return the list of images
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Image> listByCategory(Integer categoryId, boolean rafraichir) throws IOException,
+	    ProxyAuthenticationException {
+	return dao.listByCategory(categoryId, rafraichir);
+    }
+
+    /**
+     * Method called to send an image to the server.
+     * @param filePath
+     * @param idCategory
+     * @param originalWidth width for the original image
+     * @param originalHeight height for the original image
+     * @return true if the image is created
+     * @throws IOException
+     * @throws WrongChunkSizeException
+     * @throws ProxyAuthenticationException
+     * @throws FileAlreadyExistsException
+     * @throws NoSuchAlgorithmException
+     * @throws Exception
+     */
+    public boolean create(String filePath, Integer idCategory, Integer originalWidth, Integer originalHeight,
+	    Double chunckSize, Integer privacyLevel) throws IOException, NoSuchAlgorithmException,
+	    FileAlreadyExistsException, ProxyAuthenticationException, WrongChunkSizeException {
+	File originalFile = new File(filePath);
+	//get the byte array of the original file, to keep metadata
+	byte[] bytesFichierOriginal = Tools.getBytesFromFile(originalFile);
+
+	//resize the picture (or not)
+	boolean originaleRedimensionnee = ImagesUtil.scale(filePath, "originale.jpg", originalWidth, originalHeight);
+	//create the thumbnail
+	ImagesUtil.scale(filePath, "thumb.jpg", 120, 90);
+	//get the thumbnail
+	File thumbnail = new File(System.getProperty("java.io.tmpdir") + "/thumb.jpg");
+	File originale = null;
+	if (originaleRedimensionnee) {
+	    originale = new File(System.getProperty("java.io.tmpdir") + "/originale.jpg");
+	    //if the original file has been resized, we put the metadata in the resized file
+	    //I use here a try catch because if the original file isn't a jpeg
+	    //the methode Outil.enrich will fail, but the procedure has to continue
+	    try {
+		byte[] fichierEnrichi = Tools.enrich(bytesFichierOriginal, Tools.getBytesFromFile(new File(System
+			.getProperty("java.io.tmpdir")
+			+ "/originale.jpg")));
+		Tools.byteToFile(System.getProperty("java.io.tmpdir") + "/originale.jpg", fichierEnrichi);
+	    } catch (Exception e) {
+	    }
+	} else {
+	    originale = originalFile;
+
+	}
+	Image image = new Image();
+	image.setName(getImageName(filePath));
+	image.setThumbnail(thumbnail);
+	image.setOriginale(originale);
+	image.setIdCategory(idCategory);
+	image.setPrivacyLevel(String.valueOf(privacyLevel));
+	//now we call the dao to send the image to the webservice
+	return dao.create(image, chunckSize * 1000000);
+    }
+
+    /**
+     * Add tags to an existing image
+     * @param image the image
+     * @param tagId the ids of the tags
+     * @return true if successful
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public boolean addTags(Image image, String tagId) throws IOException, ProxyAuthenticationException {
+	return dao.addTags(image.getIdentifier(), tagId);
+    }
+
+    /**
+     * Search images from a string
+     * @param queryString the string
+     * @return images matching the string
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Image> search(String queryString) throws IOException, ProxyAuthenticationException {
+	return dao.search(queryString);
+    }
+
+    /**
+     * Deletes the file extension
+     * @param path
+     * @return
+     */
+    private String getImageName(String path) {
+	File fichier = new File(path);
+	StringBuffer name = new StringBuffer(fichier.getName());
+	return (name.delete(name.lastIndexOf("."), name.length())).toString();
+
+    }
+
+    public ImageDao getDao() {
+	return dao;
+    }
+
+    public void setDao(ImageDao dao) {
+	this.dao = dao;
+    }
+
+}
Index: extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/TagServiceImpl.java
===================================================================
--- extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/TagServiceImpl.java	(revision 9919)
+++ extensions/jiwigo-ws-api/src/main/java/fr/mael/jiwigo/service/impl/TagServiceImpl.java	(revision 9919)
@@ -0,0 +1,82 @@
+package fr.mael.jiwigo.service.impl;
+
+import java.io.IOException;
+import java.util.List;
+
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+import fr.mael.jiwigo.dao.TagDao;
+import fr.mael.jiwigo.om.Image;
+import fr.mael.jiwigo.om.Tag;
+import fr.mael.jiwigo.service.TagService;
+import fr.mael.jiwigo.transverse.exception.ProxyAuthenticationException;
+
+/*
+ *  jiwigo-ws-api Piwigo webservice access Api
+ *  Copyright (c) 2010-2011 Mael mael@le-guevel.com
+ *                All Rights Reserved
+ *
+ *  This library is free software. It comes without any warranty, to
+ *  the extent permitted by applicable law. You can redistribute it
+ *  and/or modify it under the terms of the Do What The Fuck You Want
+ *  To Public License, Version 2, as published by Sam Hocevar. See
+ *  http://sam.zoy.org/wtfpl/COPYING for more details.
+ */
+/**
+ *
+
+ * @author mael
+ *
+ */
+public class TagServiceImpl implements TagService {
+    /**
+     * Logger
+     */
+    private final Logger LOG = LoggerFactory.getLogger(TagServiceImpl.class);
+
+    private TagDao dao;
+
+    /**
+     * Lists all tags
+     * @return le list of tags
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Tag> list() throws IOException, ProxyAuthenticationException {
+	return dao.list();
+    }
+
+    /**
+     * Creates a tag
+     * @param nom name of the tag
+     * @return true if the tag is created
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public boolean create(String nom) throws IOException, ProxyAuthenticationException {
+	Tag tag = new Tag();
+	tag.setName(nom);
+	return dao.create(tag);
+    }
+
+    /**
+     * Returns all the tag for an image
+     * @param image the image to check
+     * @return the list of tags
+     * @throws IOException
+     * @throws ProxyAuthenticationException
+     */
+    public List<Tag> tagsForImage(Image image) throws IOException, ProxyAuthenticationException {
+	return dao.tagsForImage(image);
+    }
+
+    public TagDao getDao() {
+	return dao;
+    }
+
+    public void setDao(TagDao dao) {
+	this.dao = dao;
+    }
+
+}
